﻿'Copyright © 2009 Wes baldwin

Public Class MainForm
    Dim nt As Threading.Thread
    Dim YearsToSimulate As ULong = 1
    Dim diffsecs As Integer

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.Show()
        Application.DoEvents()
        LoadForm()
    End Sub

    Public Sub LoadForm()
        Dim gp As New GetParams
        Dim dr As DialogResult = gp.ShowDialog(Me)
        Dim dt As Date = gp.Start
        Dim tsd As TimeSpan

        If dr <> Windows.Forms.DialogResult.OK Then End

        YearsToSimulate = gp.Value
        Progress.Maximum = SecondsInYear * YearsToSimulate / 10
        Progress.Value = 0
        StopNow = False
        tsTrue = 0
        tsTheory = 0

        nt = New Threading.Thread(New Threading.ThreadStart(AddressOf Run))
        nt.Start()

        Do
            lblTrue.Text = Format(dt.AddSeconds(tsTrue), "MM/dd/yyyy HH:mm:ss")
            lblLunar.Text = Format(dt.AddSeconds(tsTheory), "MM/dd/yyyy HH:mm:ss")
            tsd = New TimeSpan(0, 0, tsTheory - tsTrue)
            lblDiff.Text = "Days: " & tsd.Days.ToString.PadRight(3) & " Hours: " & tsd.Hours.ToString.PadRight(2) & " Minutes: " & tsd.Minutes.ToString.PadRight(2) & " Seconds: " & tsd.Seconds.ToString.PadRight(2)
            Progress.Value = tsTrue / 10
            Application.DoEvents()
        Loop While nt.IsAlive

        If StopNow Then Exit Sub
        lblTrue.Text = Format(dt.AddSeconds(tsTrue), "MM/dd/yyyy HH:mm:ss")
        lblLunar.Text = Format(dt.AddSeconds(tsTheory), "MM/dd/yyyy HH:mm:ss")
        lblDiff.Text = tsTrue - tsTheory
        tsd = New TimeSpan(0, 0, tsTheory - tsTrue)
        lblDiff.Text = "Days: " & tsd.Days.ToString.PadRight(3) & " Hours: " & tsd.Hours.ToString.PadRight(2) & " Minutes: " & tsd.Minutes.ToString.PadRight(2) & " Seconds: " & tsd.Seconds.ToString.PadRight(2)
        Progress.Value = Progress.Maximum
        Application.DoEvents()

        MsgBox("Actual difference in Seconds Precision: " & (tsTheory - tsTrue).ToString, MsgBoxStyle.Information)
    End Sub

    Dim tsTrue As Decimal
    Dim tsTheory As Decimal
    Dim SecondsInYear As ULong = 31536000
    Dim ToValue As ULong = 0
    Dim StopNow As Boolean = False

    Sub Run()
        Try
            ToValue = SecondsInYear * YearsToSimulate
            For i As ULong = 1 To ToValue Step 3600
                tsTrue += 3600
                tsTheory += 3601.1117671232869
                Threading.Thread.Sleep(0)
                If StopNow Then Exit For
            Next
        Catch ex As Exception
            MsgBox(ex.ToString)
        End Try
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        'Stop
        StopNow = True
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        'Restart
        LoadForm()
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        'Exit
        End
    End Sub
End Class
